#define INCL_WIN
#define INCL_GPI
#include <os2.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dirctrl.hpp"

#define CNR_ID             100
#define UM_LETMEKNOW      WM_USER+100
HAB hab;
static dirCtrl *tree;
/*----------------------------------------------------------------------
 Function Name: ClientWndProc

 Description:
   This is the window procedure for the client are of our window.  It is
   also the owner of the container control window.

 Parameters:
   (HWND)    hwnd - The handle of the client window.
   (ULONG)   msg  - The message to be processed.
   (MRESULT) mp1  - The first message parameter for the message.
   (MRESULT) mp2  - The second message parameter for the message.
----------------------------------------------------------------------*/
MRESULT EXPENTRY ClientWndProc (HWND hwnd, ULONG msg, MRESULT mp1, MRESULT mp2)
{
    SWP          swp;
    HPS          hps;
    RECTL        rect;
    POINTL       MousePt;
    ULONG        ulBorder;
    HWND         hwndControl;
    static char         szDir[255];
    static short cx,cy;
    static char  szMessage[200];
    POINTL       ptl;


    switch (msg)
    {
    case WM_CREATE:
        /* Create the container window.  If it creates successfully,
        * return FALSE, otherwise return TRUE to indicate an error.
        */
        tree = new dirCtrl(hab, hwnd,CNR_ID, CV_MINI,UM_LETMEKNOW);
        strcpy(szMessage,"At the left you see the directory control");
        return (MRESULT)0;

    case UM_LETMEKNOW:
        strcpy(szDir,(char *)mp1);
        WinInvalidateRect(hwnd,(RECTL *)0,FALSE);
        return 0;
    case WM_PAINT:
        hps = WinBeginPaint (hwnd, NULLHANDLE, &rect);
        WinFillRect (hps, &rect, CLR_PALEGRAY);
        ptl.x = ( LONG ) cx/2 + 10;
        ptl.y = ( LONG ) cy/2;
        GpiCharStringAt(hps,&ptl,(long)strlen(szMessage),szMessage);
        ptl.y -= 20;
        if (szDir[0])
            GpiCharStringAt(hps,&ptl,(long)strlen(szDir),szDir);
        WinEndPaint (hps);
        return (MRESULT)0;


    case WM_SIZE:        
        cx = (SHORT1FROMMP(mp2));
        cy = (SHORT2FROMMP(mp2));
        hwndControl = WinWindowFromID (hwnd,CNR_ID);
        WinSetWindowPos (hwndControl,HWND_TOP,0,0,cx/2,cy,SWP_MOVE | SWP_SIZE);
        break;
    }
    return (WinDefWindowProc (hwnd, msg, mp1, mp2));
}
/*---------------------------------------------------------------------------*/
void main(void)
{
  HMQ   hmq;
  QMSG  qmsg;
  HWND  hwndFrame;
  HWND  hwndClient;
  CHAR szClientClass[]    = "ClientClass";
  ULONG fcf = FCF_TITLEBAR | FCF_SIZEBORDER | FCF_SYSMENU |
              FCF_MINMAX | FCF_SHELLPOSITION | FCF_TASKLIST;

  hab = WinInitialize (0);
  hmq = WinCreateMsgQueue (hab, 0);

  /* Register the szClientClass window class. .
   */
  WinRegisterClass (hab, szClientClass,
                    ClientWndProc, CS_SIZEREDRAW | CS_CLIPCHILDREN,0);

  /* Create a standard frame window. */
  hwndFrame = WinCreateStdWindow (HWND_DESKTOP, /* Handle of desktop  */
                           WS_VISIBLE,          /* Window style       */
                           &fcf,                /* Creation flags     */
                           szClientClass,       /* Client Class name  */
                           szClientClass,       /* Title Bar text     */
                           0,                   /* client wnd style   */
                           NULLHANDLE,          /* hwnd of resources  */
                           0,                   /* ID of Resources    */
                           &hwndClient);        /* handle of Client   */

  while (WinGetMsg (hab, &qmsg, 0L,0,0))
       WinDispatchMsg (hab,&qmsg);

  delete tree;

  WinDestroyWindow (hwndFrame);
  WinDestroyMsgQueue (hmq);
  WinTerminate (hab);
}

